// 2016.08.10 （z-）
//オブジェクト化されたトンボから仕上りエリアを作成
//アートボード（変更・追加）、長ほーけー のいずれか。
// 2016.09.08　CS4以前のバージョンに対応。CS3以前は長方形を作成のみ。

var doc = app.activeDocument;
var sel = doc.selection;
var ary = [], ary2 = [], xAry = [], yAry = [], xAry2 = [], yAry2 = [], r = [], dlg, flag, count = 0;

main();

function main(){
coordinatesFunc (sel, ary, 0, ary2);
ary = ary.sort(sortFunc);
ary2 = ary2.sort(sortFunc);
repFunc (ary, xAry);
repFunc (ary2, xAry2);

ary = [];
ary2 = [];
coordinatesFunc (sel, ary, 1, ary2);
ary = ary.sort(sortFunc);
ary2 = ary2.sort(sortFunc);
repFunc (ary, yAry);
repFunc (ary2, yAry2);

if(xAry.length >= 5 && yAry.length >= 5) {
    if (count == 16){//ふつうのイラスタートンボなら折りトンボを無視したい XYそれぞれループしてるので8+8=16
        r[0] = xAry2[2];
        r[1] = yAry2[yAry2.length -3];
        r[2] = xAry2[xAry2.length -3];
        r[3] = yAry2[2];
        }
    else{
        r[0] = xAry[Math.floor(xAry.length / 2) - 2]; // 15/2くりさげ -2 = 5
        r[1] = yAry[Math.ceil(yAry.length / 2) + 1]; // 15/2くりあげ +1 = 9
        r[2] = xAry[Math.ceil(xAry.length / 2) + 1]; // 15/2くりあげ +1 = 9
        r[3] = yAry[Math.floor(yAry.length / 2) - 2]; // 15/2くりさげ -2 = 5
        }

    try{ //マルチアートボード搭載以前のバージョン
        var ind = doc.artboards.getActiveArtboardIndex();
        }
    catch(e){
        var rect = doc.pathItems.rectangle(r[1], r[0], r[2] - r[0], r[1] - r[3]);
        rect.stroked = false;
        doc.selection = rect;
        return;
        }
    
    if (uiFunc () == 1){
        var rect = doc.pathItems.rectangle(r[1], r[0], r[2] - r[0], r[1] - r[3]);
        if(dlg.RG.R2.value) {
            try{ //CS4対策
                doc.artboards.insert(rect.geometricBounds, doc.artboards.length);
                }
            catch(e){
                doc.artboards.add(rect.geometricBounds) ;
                }
            ind = doc.artboards.length - 1;
            //doc.artboards.setActiveArtboardIndex(ind);
            }
        if( !dlg.RG.R3.value) {
            doc.artboards[ind].artboardRect = rect.geometricBounds;
            rect.remove();
            }
        else{
            rect.stroked = false;
            doc.selection = rect;
            }
        }
    }
}

function coordinatesFunc (sel, ary, ind, ary2) {
    flag = false;
    for (var i = 0; i < sel.length; i++) {
        if(sel[i].hasOwnProperty ("pageItems")) {
            coordinatesFunc (sel[i].pageItems, ary, ind, ary2);
            continue;
            }
        if(sel[i].pathPoints.length == 3) { //ポインツ数が3ならコーナートンボ部品
            flag = true;
            count ++;
            }
        for (var j = 0; j < sel[i].pathPoints.length; j++) {
            ary.push(sel[i].pathPoints[j].anchor[ind]);
            if(flag) {
                ary2.push(sel[i].pathPoints[j].anchor[ind]);
                }
            }
        }
    }

function sortFunc(a, b) {
    return a - b;
    }

function repFunc (ary1, ary2){
    ary2.push(ary1.shift());
    while(ary1.length){
        var obj = ary1.shift();
        if(obj != ary2[ary2.length - 1]){
            ary2.push(obj);
            }
        }
    }

function uiFunc () {
    dlg = new Window("dialog{text:'仕上りエリアを作成', \
    RG:Group{orientation:'column', spacing:0, alignChildren:'left', \
    R1:RadioButton{text:'現在のアートボード', value:true}, \
    R2:RadioButton{text:'新規アートボード'}, \
    R3:RadioButton{text:'長方形を作成'}\
    }, \
    BG:Group{orientation:'row', \
    CB:Button{text:'Cancel', properties:{name:'cancel'}}, \
    PB:Button{text:'Please', properties:{name:'ok'}}}\
    }");
    return dlg.show();
    }